; HSV toolkit v1.00.					   2006 Marcel Kilgus

	section hsv

	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qlv'
	include 'dev8_keys_err'
	include 'dev8_keys_sbasic'
	include 'dev8_mac_proc'

	xref	ut_gtint
	xref	ut_gxlin
	xref	ut_gxli1
	xref	ut_rtint
	xref	ut_rtfd1

cv_initp
	lea	cv_procs,a1
	move.w	sb.inipr,a2
	jmp	(a2)

cv_procs
	proc_stt
	proc_ref HSV_RCHP
	proc_end
	proc_stt
	proc_ref HSV_GETH
	proc_ref HSV_GETS
	proc_ref HSV_GETV
	proc_ref HSV_GETR
	proc_ref HSV_GETG
	proc_ref HSV_GETB
	proc_ref HSV_GETRGB
	proc_ref HSV_HSSPR
	proc_ref HSV_VSPR
	proc_end

hsv_geth
	bsr.s	hsv_get
	jmp	ut_rtint

hsv_gets
	bsr.s	hsv_get
	move.w	d2,d1
	jmp	ut_rtint

hsv_getv
	bsr.s	hsv_get
	move.w	d3,d1
	jmp	ut_rtint

hsv_get
	jsr	ut_gtint
	cmp.w	#3,d3
	bne.s	hg_ipar
	moveq	#0,d5
	moveq	#0,d6
	moveq	#0,d7
	move.w	(a6,a1.l),d5
	bmi	hsv_iparr
	cmp.w	#$100,d5
	bge	hsv_iparr
	move.w	2(a6,a1.l),d6
	bmi	hsv_iparr
	cmp.w	#$100,d6
	bge	hsv_iparr
	move.w	4(a6,a1.l),d7
	bmi	hsv_iparr
	cmp.w	#$100,d7
	bge	hsv_iparr
	addq.l	#6,a1
	move.l	a1,sb_arthp(a6)
	bra.s	rgb2hsv

hg_ipar
	moveq	#err.ipar,d0
	addq.l	#4,a7
	rts

hsv_getr
	bsr.s	rgb_get
	jmp	ut_rtint

hsv_getg
	bsr.s	rgb_get
	move.w	d2,d1
	jmp	ut_rtint

hsv_getb
	bsr.s	rgb_get
	move.w	d3,d1
	jmp	ut_rtint

hsv_getrgb
	bsr.s	rgb_get
	andi.w	#$ff,d1
	lsl.l	#8,d1
	move.b	d2,d1
	lsl.l	#8,d1
	move.b	d3,d1
	jmp	ut_rtfd1

rgb_get
	jsr	ut_gtint
	cmp.w	#3,d3
	bne.s	hg_ipar
	moveq	#0,d5
	moveq	#0,d6
	moveq	#0,d7
	move.w	(a6,a1.l),d5
	bmi.s	hsv_iparr
	cmp.w	#$100,d5
	bge.s	hsv_iparr
	move.w	2(a6,a1.l),d6
	bmi.s	hsv_iparr
	cmp.w	#$100,d6
	bge.s	hsv_iparr
	move.w	4(a6,a1.l),d7
	bmi.s	hsv_iparr
	cmp.w	#$100,d7
	bge.s	hsv_iparr
	addq.l	#6,a1
	move.l	a1,sb_arthp(a6)
	bra	hsv2rgb

hsv_iparr
	addq.w	#4,sp
	moveq	#err.ipar,d0
	rts

;+++
; Convert RGB value to HSV.
;
;	d0     s
;	d1  r	 hue (0-255), -1 if undefined
;	d2  r	 saturation (0-255)
;	d3  r	 value (0-255)
;	d4     s
;	d5 c   p red (0-255)
;	d6 c   p green (0-255)
;	d7 c   p blue (255)
;---
rgb2hsv
	moveq	#0,d4		; 0 = red, 1 = green, 2 = blue is max
	move.w	d5,d3		; max value
	move.w	d5,d1		; min value
	cmp.w	d6,d3
	bge.s	rgb_redmax
	move.w	d6,d3		; new max
	moveq	#1,d4
	bra.s	rgb_red
rgb_redmax
	beq.s	rgb_red
	move.w	d6,d1		; new min
rgb_red
	cmp.w	d7,d3
	bge.s	rgb_bluemax
	move.w	d7,d3		; new max
	moveq	#2,d4
	bra.s	rgb_blue
rgb_bluemax
	cmp.w	d7,d1
	ble.s	rgb_blue
	move.w	d7,d1		; new min
rgb_blue
	move.w	d3,d0
	sub.w	d1,d0		; delta

	tst.w	d3
	bne.s	rgb_vnot0	; max = 0 -> all 0
	moveq	#0,d1
	moveq	#0,d2
	rts

rgb_vnot0
	moveq	#0,d2
	move.w	d0,d2
	lsl.w	#8,d2
	divu	d3,d2		; s = delta / max
	bne.s	rgb_snot0
	moveq	#-1,d1		; if s = 0 then hue is undefined
	rts
rgb_snot0
	subq.w	#1,d4
	bmi.s	rgb_0
	beq.s	rgb_1

	move.w	d5,d1		; mag < h < cyan
	sub.w	d6,d1		; h = 4*43 + ( r - g ) / delta
	muls	#43,d1
	divs	d0,d1
	add.w	#4*43,d1
	bra.s	rgb_all

rgb_0
	move.w	d6,d1		; yellow < h < mag
	sub.w	d7,d1		; h = ( g - b ) / delta
	muls	#43,d1
	divs	d0,d1
	bra.s	rgb_all

rgb_1
	move.w	d7,d1		; cyan < h < yellow
	sub.w	d5,d1		; h = 2*43 + ( b - r ) / delta
	muls	#43,d1
	divs	d0,d1
	add.w	#2*43,d1
rgb_all
	tst.w	d1
	bge.s	rgb_rts
	add.w	#256,d1
rgb_rts
	rts

;+++
; Convert HSV value to RGB, with V fixed to maximum
;
;	d0     s
;	d1  r	 red (0-255)
;	d2  r	 green (0-255)
;	d3  r	 blue (0-255)
;	d4     s
;	d5 c   p hue (0-255)
;	d6 c   p saturation (0-255)
;	d7  r	 value (255)
;---
hs2rgb
	move.l	d5,d4		; hue
	divu	#43,d4
	swap	d4		; section / F (in 43rds)

	move.w	#255,d1
	move.w	d1,d3
	sub.w	d6,d1		; P = 1 - S

	move.w	d6,d0
	mulu	d4,d0		; S * F
	divu	#43,d0		; normalize 0..255
	move.w	d6,d2
	sub.w	d0,d2
	sub.w	d2,d3		; T

	move.w	#255,d2
	move.w	d2,d7		; fixed V
	sub.w	d0,d2		; Q

	swap	d4		; section
	add.w	d4,d4
	move.w	sec_tab(pc,d4.w),d4
	jmp	sec_tab(pc,d4.w)

;+++
; Convert HSV value to RGB
;
;	d0     s
;	d1  r	 red (0-255)
;	d2  r	 green (0-255)
;	d3  r	 blue (0-255)
;	d4     s
;	d5 c   p hue (0-255)
;	d6 c   p saturation (0-255)
;	d7 c   p value (0-255)
;---
hsv2rgb
	move.l	d5,d4		; hue
	divu	#43,d4
	swap	d4		; section / F (in 43rds)

	move.w	#255,d1
	move.w	d1,d3
	sub.w	d6,d1		; P = 1 - S

	move.w	d6,d0
	mulu	d4,d0		; S * F
	divu	#43,d0		; normalize 0..255
	move.w	d6,d2
	sub.w	d0,d2
	sub.w	d2,d3		; T

	move.w	#255,d2
	sub.w	d0,d2		; Q

	mulu	d7,d1		; all factors * V
	mulu	d7,d2
	mulu	d7,d3
	lsr.w	#8,d1		; normalize
	lsr.w	#8,d2
	lsr.w	#8,d3

	swap	d4		; section
	add.w	d4,d4
	move.w	sec_tab(pc,d4.w),d4
	jmp	sec_tab(pc,d4.w)

sec_tab
	dc.w	sec0-sec_tab
	dc.w	sec1-sec_tab
	dc.w	sec2-sec_tab
	dc.w	sec3-sec_tab
	dc.w	sec4-sec_tab
	dc.w	sec5-sec_tab

sec0
	move.w	d3,d2
	move.w	d1,d3
	move.w	d7,d1
	rts

sec1
	move.w	d1,d3
	move.w	d2,d1
	move.w	d7,d2
	rts

sec2
	move.w	d7,d2
	rts

sec3
	move.w	d7,d3
	rts

sec4
	move.w	d1,d2
	move.w	d3,d1
	move.w	d7,d3
	rts

sec5
	move.w	d2,d3
	move.w	d1,d2
	move.w	d7,d1
	rts

; Sprite generation routines

sz	equ	128		; plane x/y size, ramp y size
xs	equ	16		; ramp x size

;+++
; Build 24 bit H/S plane sprite (128x128) with V = max
;
; adr = HSV_HSSPR
;---
hsv_hsspr
	cmpa.l	a3,a5
	bne.s	hsv_ipar

	movem.l d2-d7/a0-a3,-(sp)
	moveq	#sms.achp,d0
	move.l	#sz*sz*4*2+6*4,d1     ; room for sprite
	moveq	#-1,d2
	trap	#1
	tst.l	d0
	bne.s	hsh_exit
	move.l	a0,-(sp)
	move.l	a0,a1

	move.l	#$02400003,(a1)+; 24 bit mode, force cache update
	move.w	#sz,(a1)+	; x size
	move.w	#sz,(a1)+	; y size
	clr.l	(a1)+		; 0,0 origin
	move.l	#12,(a1)+	; ptr to pattern
	move.l	#8+sz*sz*4,(a1)+; ptr to mask
	clr.l	(a1)+		; no next sprite

	move.w	#255,d6 	; saturation (0 ... 255)
hsh_s
	moveq	#0,d5		; hue (0 ... 255)
hsh_h
	bsr	hs2rgb
	swap	d1		; R
	move.b	d2,d1		; G
	lsl.w	#8,d1
	move.b	d3,d1		; B
	lsl.l	#8,d1		; RGB0

	move.l	d1,(a1)+	; set colour

	addq.b	#2,d5
	bcc.s	hsh_h
	subq.b	#2,d6
	bcc.s	hsh_s

	move.l	#sz*sz-1,d0	; build pattern
	moveq	#-1,d1
hsh_p
	move.l	d1,(a1)+	; pattern is solid
	dbf	d0,hsh_p

	move.l	(sp)+,d1	; address of sprite
	movem.l (sp)+,d2-d7/a0-a3
	jmp	ut_rtfd1	; return float

hsh_exit
	movem.l (sp)+,d1-d7/a0-a3
	rts

hsv_ipar
	moveq	#err.ipar,d0
hsv_exit
	rts

;+++
; Build 24 bit V ramp sprite (10x128) with given H/S
;
; adr = HSV_VSPR(x, H, S)
;
; if x = 0 then new memory is allocated and returned in adr. If x is != 0
; then x is returned as it is.
;	d0  r	error code
;	d5 c  p hue
;	d6 c  p saturation
;	a1 cr p room for sprite (must be big enough!)
;---
hsv_vspr
	moveq	#$18,d0 	; check for exactly 3 parameters
	jsr	ut_gxlin
	bne	hsv_exit

	movem.l d2-d7/a1,-(sp)
	move.l	4(a6,a1.l),d5	; H
	move.l	8(a6,a1.l),d6	; S
	move.l	(a6,a1.l),d0	; x
	move.l	d0,a0
	adda.w	#12,a1		; remove parameters from stack
	bne.s	hsv_allocated

	moveq	#sms.achp,d0
	move.l	#xs*sz*4*2+6*4,d1	; room for sprite
	moveq	#-1,d2
	trap	#1

hsv_allocated
	move.l	a0,a1
	move.l	#$02400003,(a1)+; 24 bit mode, force cache update
	move.w	#xs,(a1)+	; x size
	move.w	#sz,(a1)+	; y size
	clr.l	(a1)+		; 0,0 origin
	move.l	#12,(a1)+	; ptr to pattern
	move.l	#8+xs*sz*4,(a1)+; ptr to mask
	clr.l	(a1)+		; no next sprite

	move.b	#255,d7 	; Value
hsv_v
	bsr	hsv2rgb
	swap	d1		; R
	move.b	d2,d1		; G
	lsl.w	#8,d1
	move.b	d3,d1		; B

	lsl.l	#8,d1		; RGB0

	moveq	#xs-1,d0
hsv_x
	move.l	d1,(a1)+	; set colour
	dbf	d0,hsv_x

	subq.b	#2,d7
	bcc.s	hsv_v

	move.l	#xs*sz-1,d0	; build pattern
	moveq	#-1,d1
hsv_p
	move.l	d1,(a1)+	; pattern is solid
	dbf	d0,hsv_p

	move.l	a0,d1
	movem.l (sp)+,d2-d7/a1
	move.l	a1,sb_arthp(a6)
	jmp	ut_rtfd1	; return float

;+++
; Simple wrapper for sms.rchp
;
; HSV_RCHP adr
;---
hsv_rchp
	jsr	ut_gxli1
	bne	hsv_exit

	move.l	(a6,a1.l),a0	; adr
	movem.l a1-a3,-(sp)
	moveq	#sms.rchp,d0
	trap	#1
	movem.l (sp)+,a1-a3
	rts

	end
